goog.provide('shadow.remote.runtime.shared');
shadow.remote.runtime.shared.init_state = (function shadow$remote$runtime$shared$init_state(client_info){
return new cljs.core.PersistentArrayMap(null, 5, [new cljs.core.Keyword(null,"extensions","extensions",-1103629196),cljs.core.PersistentArrayMap.EMPTY,new cljs.core.Keyword(null,"ops","ops",1237330063),cljs.core.PersistentArrayMap.EMPTY,new cljs.core.Keyword(null,"client-info","client-info",1958982504),client_info,new cljs.core.Keyword(null,"call-id-seq","call-id-seq",-1679248218),(0),new cljs.core.Keyword(null,"call-handlers","call-handlers",386605551),cljs.core.PersistentArrayMap.EMPTY], null);
});
shadow.remote.runtime.shared.now = (function shadow$remote$runtime$shared$now(){
return Date.now();
});
shadow.remote.runtime.shared.get_client_id = (function shadow$remote$runtime$shared$get_client_id(p__18607){
var map__18608 = p__18607;
var map__18608__$1 = cljs.core.__destructure_map(map__18608);
var runtime = map__18608__$1;
var state_ref = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__18608__$1,new cljs.core.Keyword(null,"state-ref","state-ref",2127874952));
var or__5045__auto__ = new cljs.core.Keyword(null,"client-id","client-id",-464622140).cljs$core$IFn$_invoke$arity$1(cljs.core.deref(state_ref));
if(cljs.core.truth_(or__5045__auto__)){
return or__5045__auto__;
} else {
throw cljs.core.ex_info.cljs$core$IFn$_invoke$arity$2("runtime has no assigned runtime-id",new cljs.core.PersistentArrayMap(null, 1, [new cljs.core.Keyword(null,"runtime","runtime",-1331573996),runtime], null));
}
});
shadow.remote.runtime.shared.relay_msg = (function shadow$remote$runtime$shared$relay_msg(runtime,msg){
var self_id_18689 = shadow.remote.runtime.shared.get_client_id(runtime);
if(cljs.core.not_EQ_.cljs$core$IFn$_invoke$arity$2(new cljs.core.Keyword(null,"to","to",192099007).cljs$core$IFn$_invoke$arity$1(msg),self_id_18689)){
shadow.remote.runtime.api.relay_msg(runtime,msg);
} else {
Promise.resolve((1)).then((function (){
var G__18609 = runtime;
var G__18610 = cljs.core.assoc.cljs$core$IFn$_invoke$arity$3(msg,new cljs.core.Keyword(null,"from","from",1815293044),self_id_18689);
return (shadow.remote.runtime.shared.process.cljs$core$IFn$_invoke$arity$2 ? shadow.remote.runtime.shared.process.cljs$core$IFn$_invoke$arity$2(G__18609,G__18610) : shadow.remote.runtime.shared.process.call(null,G__18609,G__18610));
}));
}

return msg;
});
shadow.remote.runtime.shared.reply = (function shadow$remote$runtime$shared$reply(runtime,p__18611,res){
var map__18612 = p__18611;
var map__18612__$1 = cljs.core.__destructure_map(map__18612);
var call_id = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__18612__$1,new cljs.core.Keyword(null,"call-id","call-id",1043012968));
var from = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__18612__$1,new cljs.core.Keyword(null,"from","from",1815293044));
var res__$1 = (function (){var G__18613 = res;
var G__18613__$1 = (cljs.core.truth_(call_id)?cljs.core.assoc.cljs$core$IFn$_invoke$arity$3(G__18613,new cljs.core.Keyword(null,"call-id","call-id",1043012968),call_id):G__18613);
if(cljs.core.truth_(from)){
return cljs.core.assoc.cljs$core$IFn$_invoke$arity$3(G__18613__$1,new cljs.core.Keyword(null,"to","to",192099007),from);
} else {
return G__18613__$1;
}
})();
return shadow.remote.runtime.api.relay_msg(runtime,res__$1);
});
shadow.remote.runtime.shared.call = (function shadow$remote$runtime$shared$call(var_args){
var G__18616 = arguments.length;
switch (G__18616) {
case 3:
return shadow.remote.runtime.shared.call.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
case 4:
return shadow.remote.runtime.shared.call.cljs$core$IFn$_invoke$arity$4((arguments[(0)]),(arguments[(1)]),(arguments[(2)]),(arguments[(3)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

(shadow.remote.runtime.shared.call.cljs$core$IFn$_invoke$arity$3 = (function (runtime,msg,handlers){
return shadow.remote.runtime.shared.call.cljs$core$IFn$_invoke$arity$4(runtime,msg,handlers,(0));
}));

(shadow.remote.runtime.shared.call.cljs$core$IFn$_invoke$arity$4 = (function (p__18617,msg,handlers,timeout_after_ms){
var map__18618 = p__18617;
var map__18618__$1 = cljs.core.__destructure_map(map__18618);
var runtime = map__18618__$1;
var state_ref = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__18618__$1,new cljs.core.Keyword(null,"state-ref","state-ref",2127874952));
if(cljs.core.map_QMARK_(msg)){
} else {
throw (new Error("Assert failed: (map? msg)"));
}

if(cljs.core.map_QMARK_(handlers)){
} else {
throw (new Error("Assert failed: (map? handlers)"));
}

if(cljs.core.nat_int_QMARK_(timeout_after_ms)){
} else {
throw (new Error("Assert failed: (nat-int? timeout-after-ms)"));
}

var call_id = new cljs.core.Keyword(null,"call-id-seq","call-id-seq",-1679248218).cljs$core$IFn$_invoke$arity$1(cljs.core.deref(state_ref));
cljs.core.swap_BANG_.cljs$core$IFn$_invoke$arity$4(state_ref,cljs.core.update,new cljs.core.Keyword(null,"call-id-seq","call-id-seq",-1679248218),cljs.core.inc);

cljs.core.swap_BANG_.cljs$core$IFn$_invoke$arity$4(state_ref,cljs.core.assoc_in,new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"call-handlers","call-handlers",386605551),call_id], null),new cljs.core.PersistentArrayMap(null, 4, [new cljs.core.Keyword(null,"handlers","handlers",79528781),handlers,new cljs.core.Keyword(null,"called-at","called-at",607081160),shadow.remote.runtime.shared.now(),new cljs.core.Keyword(null,"msg","msg",-1386103444),msg,new cljs.core.Keyword(null,"timeout","timeout",-318625318),timeout_after_ms], null));

return shadow.remote.runtime.api.relay_msg(runtime,cljs.core.assoc.cljs$core$IFn$_invoke$arity$3(msg,new cljs.core.Keyword(null,"call-id","call-id",1043012968),call_id));
}));

(shadow.remote.runtime.shared.call.cljs$lang$maxFixedArity = 4);

shadow.remote.runtime.shared.trigger_BANG_ = (function shadow$remote$runtime$shared$trigger_BANG_(var_args){
var args__5775__auto__ = [];
var len__5769__auto___18691 = arguments.length;
var i__5770__auto___18692 = (0);
while(true){
if((i__5770__auto___18692 < len__5769__auto___18691)){
args__5775__auto__.push((arguments[i__5770__auto___18692]));

var G__18693 = (i__5770__auto___18692 + (1));
i__5770__auto___18692 = G__18693;
continue;
} else {
}
break;
}

var argseq__5776__auto__ = ((((2) < args__5775__auto__.length))?(new cljs.core.IndexedSeq(args__5775__auto__.slice((2)),(0),null)):null);
return shadow.remote.runtime.shared.trigger_BANG_.cljs$core$IFn$_invoke$arity$variadic((arguments[(0)]),(arguments[(1)]),argseq__5776__auto__);
});

(shadow.remote.runtime.shared.trigger_BANG_.cljs$core$IFn$_invoke$arity$variadic = (function (p__18623,ev,args){
var map__18625 = p__18623;
var map__18625__$1 = cljs.core.__destructure_map(map__18625);
var runtime = map__18625__$1;
var state_ref = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__18625__$1,new cljs.core.Keyword(null,"state-ref","state-ref",2127874952));
var seq__18628 = cljs.core.seq(cljs.core.vals(new cljs.core.Keyword(null,"extensions","extensions",-1103629196).cljs$core$IFn$_invoke$arity$1(cljs.core.deref(state_ref))));
var chunk__18631 = null;
var count__18632 = (0);
var i__18633 = (0);
while(true){
if((i__18633 < count__18632)){
var ext = chunk__18631.cljs$core$IIndexed$_nth$arity$2(null,i__18633);
var ev_fn = cljs.core.get.cljs$core$IFn$_invoke$arity$2(ext,ev);
if(cljs.core.truth_(ev_fn)){
cljs.core.apply.cljs$core$IFn$_invoke$arity$2(ev_fn,args);


var G__18694 = seq__18628;
var G__18695 = chunk__18631;
var G__18696 = count__18632;
var G__18697 = (i__18633 + (1));
seq__18628 = G__18694;
chunk__18631 = G__18695;
count__18632 = G__18696;
i__18633 = G__18697;
continue;
} else {
var G__18698 = seq__18628;
var G__18699 = chunk__18631;
var G__18700 = count__18632;
var G__18701 = (i__18633 + (1));
seq__18628 = G__18698;
chunk__18631 = G__18699;
count__18632 = G__18700;
i__18633 = G__18701;
continue;
}
} else {
var temp__5804__auto__ = cljs.core.seq(seq__18628);
if(temp__5804__auto__){
var seq__18628__$1 = temp__5804__auto__;
if(cljs.core.chunked_seq_QMARK_(seq__18628__$1)){
var c__5568__auto__ = cljs.core.chunk_first(seq__18628__$1);
var G__18702 = cljs.core.chunk_rest(seq__18628__$1);
var G__18703 = c__5568__auto__;
var G__18704 = cljs.core.count(c__5568__auto__);
var G__18705 = (0);
seq__18628 = G__18702;
chunk__18631 = G__18703;
count__18632 = G__18704;
i__18633 = G__18705;
continue;
} else {
var ext = cljs.core.first(seq__18628__$1);
var ev_fn = cljs.core.get.cljs$core$IFn$_invoke$arity$2(ext,ev);
if(cljs.core.truth_(ev_fn)){
cljs.core.apply.cljs$core$IFn$_invoke$arity$2(ev_fn,args);


var G__18706 = cljs.core.next(seq__18628__$1);
var G__18707 = null;
var G__18708 = (0);
var G__18709 = (0);
seq__18628 = G__18706;
chunk__18631 = G__18707;
count__18632 = G__18708;
i__18633 = G__18709;
continue;
} else {
var G__18710 = cljs.core.next(seq__18628__$1);
var G__18711 = null;
var G__18712 = (0);
var G__18713 = (0);
seq__18628 = G__18710;
chunk__18631 = G__18711;
count__18632 = G__18712;
i__18633 = G__18713;
continue;
}
}
} else {
return null;
}
}
break;
}
}));

(shadow.remote.runtime.shared.trigger_BANG_.cljs$lang$maxFixedArity = (2));

/** @this {Function} */
(shadow.remote.runtime.shared.trigger_BANG_.cljs$lang$applyTo = (function (seq18620){
var G__18621 = cljs.core.first(seq18620);
var seq18620__$1 = cljs.core.next(seq18620);
var G__18622 = cljs.core.first(seq18620__$1);
var seq18620__$2 = cljs.core.next(seq18620__$1);
var self__5754__auto__ = this;
return self__5754__auto__.cljs$core$IFn$_invoke$arity$variadic(G__18621,G__18622,seq18620__$2);
}));

shadow.remote.runtime.shared.welcome = (function shadow$remote$runtime$shared$welcome(p__18638,p__18639){
var map__18640 = p__18638;
var map__18640__$1 = cljs.core.__destructure_map(map__18640);
var runtime = map__18640__$1;
var state_ref = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__18640__$1,new cljs.core.Keyword(null,"state-ref","state-ref",2127874952));
var map__18641 = p__18639;
var map__18641__$1 = cljs.core.__destructure_map(map__18641);
var msg = map__18641__$1;
var client_id = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__18641__$1,new cljs.core.Keyword(null,"client-id","client-id",-464622140));
cljs.core.swap_BANG_.cljs$core$IFn$_invoke$arity$4(state_ref,cljs.core.assoc,new cljs.core.Keyword(null,"client-id","client-id",-464622140),client_id);

var map__18642 = cljs.core.deref(state_ref);
var map__18642__$1 = cljs.core.__destructure_map(map__18642);
var client_info = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__18642__$1,new cljs.core.Keyword(null,"client-info","client-info",1958982504));
var extensions = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__18642__$1,new cljs.core.Keyword(null,"extensions","extensions",-1103629196));
shadow.remote.runtime.shared.relay_msg(runtime,new cljs.core.PersistentArrayMap(null, 2, [new cljs.core.Keyword(null,"op","op",-1882987955),new cljs.core.Keyword(null,"hello","hello",-245025397),new cljs.core.Keyword(null,"client-info","client-info",1958982504),client_info], null));

return shadow.remote.runtime.shared.trigger_BANG_(runtime,new cljs.core.Keyword(null,"on-welcome","on-welcome",1895317125));
});
shadow.remote.runtime.shared.ping = (function shadow$remote$runtime$shared$ping(runtime,msg){
return shadow.remote.runtime.shared.reply(runtime,msg,new cljs.core.PersistentArrayMap(null, 1, [new cljs.core.Keyword(null,"op","op",-1882987955),new cljs.core.Keyword(null,"pong","pong",-172484958)], null));
});
shadow.remote.runtime.shared.request_supported_ops = (function shadow$remote$runtime$shared$request_supported_ops(p__18643,msg){
var map__18644 = p__18643;
var map__18644__$1 = cljs.core.__destructure_map(map__18644);
var runtime = map__18644__$1;
var state_ref = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__18644__$1,new cljs.core.Keyword(null,"state-ref","state-ref",2127874952));
return shadow.remote.runtime.shared.reply(runtime,msg,new cljs.core.PersistentArrayMap(null, 2, [new cljs.core.Keyword(null,"op","op",-1882987955),new cljs.core.Keyword(null,"supported-ops","supported-ops",337914702),new cljs.core.Keyword(null,"ops","ops",1237330063),cljs.core.disj.cljs$core$IFn$_invoke$arity$variadic(cljs.core.set(cljs.core.keys(new cljs.core.Keyword(null,"ops","ops",1237330063).cljs$core$IFn$_invoke$arity$1(cljs.core.deref(state_ref)))),new cljs.core.Keyword(null,"welcome","welcome",-578152123),cljs.core.prim_seq.cljs$core$IFn$_invoke$arity$2([new cljs.core.Keyword(null,"unknown-relay-op","unknown-relay-op",170832753),new cljs.core.Keyword(null,"unknown-op","unknown-op",1900385996),new cljs.core.Keyword(null,"request-supported-ops","request-supported-ops",-1034994502),new cljs.core.Keyword(null,"tool-disconnect","tool-disconnect",189103996)], 0))], null));
});
shadow.remote.runtime.shared.unknown_relay_op = (function shadow$remote$runtime$shared$unknown_relay_op(msg){
return console.warn("unknown-relay-op",msg);
});
shadow.remote.runtime.shared.unknown_op = (function shadow$remote$runtime$shared$unknown_op(msg){
return console.warn("unknown-op",msg);
});
shadow.remote.runtime.shared.add_extension_STAR_ = (function shadow$remote$runtime$shared$add_extension_STAR_(p__18647,key,p__18648){
var map__18649 = p__18647;
var map__18649__$1 = cljs.core.__destructure_map(map__18649);
var state = map__18649__$1;
var extensions = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__18649__$1,new cljs.core.Keyword(null,"extensions","extensions",-1103629196));
var map__18650 = p__18648;
var map__18650__$1 = cljs.core.__destructure_map(map__18650);
var spec = map__18650__$1;
var ops = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__18650__$1,new cljs.core.Keyword(null,"ops","ops",1237330063));
if(cljs.core.contains_QMARK_(extensions,key)){
throw cljs.core.ex_info.cljs$core$IFn$_invoke$arity$2("extension already registered",new cljs.core.PersistentArrayMap(null, 2, [new cljs.core.Keyword(null,"key","key",-1516042587),key,new cljs.core.Keyword(null,"spec","spec",347520401),spec], null));
} else {
}

return cljs.core.reduce_kv((function (state__$1,op_kw,op_handler){
if(cljs.core.truth_(cljs.core.get_in.cljs$core$IFn$_invoke$arity$2(state__$1,new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"ops","ops",1237330063),op_kw], null)))){
throw cljs.core.ex_info.cljs$core$IFn$_invoke$arity$2("op already registered",new cljs.core.PersistentArrayMap(null, 2, [new cljs.core.Keyword(null,"key","key",-1516042587),key,new cljs.core.Keyword(null,"op","op",-1882987955),op_kw], null));
} else {
}

return cljs.core.assoc_in(state__$1,new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"ops","ops",1237330063),op_kw], null),op_handler);
}),cljs.core.assoc_in(state,new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"extensions","extensions",-1103629196),key], null),spec),ops);
});
shadow.remote.runtime.shared.add_extension = (function shadow$remote$runtime$shared$add_extension(p__18664,key,spec){
var map__18665 = p__18664;
var map__18665__$1 = cljs.core.__destructure_map(map__18665);
var state_ref = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__18665__$1,new cljs.core.Keyword(null,"state-ref","state-ref",2127874952));
return cljs.core.swap_BANG_.cljs$core$IFn$_invoke$arity$4(state_ref,shadow.remote.runtime.shared.add_extension_STAR_,key,spec);
});
shadow.remote.runtime.shared.add_defaults = (function shadow$remote$runtime$shared$add_defaults(runtime){
return shadow.remote.runtime.shared.add_extension(runtime,new cljs.core.Keyword("shadow.remote.runtime.shared","defaults","shadow.remote.runtime.shared/defaults",-1821257543),new cljs.core.PersistentArrayMap(null, 1, [new cljs.core.Keyword(null,"ops","ops",1237330063),new cljs.core.PersistentArrayMap(null, 5, [new cljs.core.Keyword(null,"welcome","welcome",-578152123),(function (p1__18666_SHARP_){
return shadow.remote.runtime.shared.welcome(runtime,p1__18666_SHARP_);
}),new cljs.core.Keyword(null,"unknown-relay-op","unknown-relay-op",170832753),(function (p1__18667_SHARP_){
return shadow.remote.runtime.shared.unknown_relay_op(p1__18667_SHARP_);
}),new cljs.core.Keyword(null,"unknown-op","unknown-op",1900385996),(function (p1__18668_SHARP_){
return shadow.remote.runtime.shared.unknown_op(p1__18668_SHARP_);
}),new cljs.core.Keyword(null,"ping","ping",-1670114784),(function (p1__18669_SHARP_){
return shadow.remote.runtime.shared.ping(runtime,p1__18669_SHARP_);
}),new cljs.core.Keyword(null,"request-supported-ops","request-supported-ops",-1034994502),(function (p1__18670_SHARP_){
return shadow.remote.runtime.shared.request_supported_ops(runtime,p1__18670_SHARP_);
})], null)], null));
});
shadow.remote.runtime.shared.del_extension_STAR_ = (function shadow$remote$runtime$shared$del_extension_STAR_(state,key){
var ext = cljs.core.get_in.cljs$core$IFn$_invoke$arity$2(state,new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"extensions","extensions",-1103629196),key], null));
if(cljs.core.not(ext)){
return state;
} else {
return cljs.core.reduce_kv((function (state__$1,op_kw,op_handler){
return cljs.core.update_in.cljs$core$IFn$_invoke$arity$4(state__$1,new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"ops","ops",1237330063)], null),cljs.core.dissoc,op_kw);
}),cljs.core.update.cljs$core$IFn$_invoke$arity$4(state,new cljs.core.Keyword(null,"extensions","extensions",-1103629196),cljs.core.dissoc,key),new cljs.core.Keyword(null,"ops","ops",1237330063).cljs$core$IFn$_invoke$arity$1(ext));
}
});
shadow.remote.runtime.shared.del_extension = (function shadow$remote$runtime$shared$del_extension(p__18671,key){
var map__18672 = p__18671;
var map__18672__$1 = cljs.core.__destructure_map(map__18672);
var state_ref = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__18672__$1,new cljs.core.Keyword(null,"state-ref","state-ref",2127874952));
return cljs.core.swap_BANG_.cljs$core$IFn$_invoke$arity$3(state_ref,shadow.remote.runtime.shared.del_extension_STAR_,key);
});
shadow.remote.runtime.shared.unhandled_call_result = (function shadow$remote$runtime$shared$unhandled_call_result(call_config,msg){
return console.warn("unhandled call result",msg,call_config);
});
shadow.remote.runtime.shared.unhandled_client_not_found = (function shadow$remote$runtime$shared$unhandled_client_not_found(p__18673,msg){
var map__18674 = p__18673;
var map__18674__$1 = cljs.core.__destructure_map(map__18674);
var runtime = map__18674__$1;
var state_ref = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__18674__$1,new cljs.core.Keyword(null,"state-ref","state-ref",2127874952));
return shadow.remote.runtime.shared.trigger_BANG_.cljs$core$IFn$_invoke$arity$variadic(runtime,new cljs.core.Keyword(null,"on-client-not-found","on-client-not-found",-642452849),cljs.core.prim_seq.cljs$core$IFn$_invoke$arity$2([msg], 0));
});
shadow.remote.runtime.shared.reply_unknown_op = (function shadow$remote$runtime$shared$reply_unknown_op(runtime,msg){
return shadow.remote.runtime.shared.reply(runtime,msg,new cljs.core.PersistentArrayMap(null, 2, [new cljs.core.Keyword(null,"op","op",-1882987955),new cljs.core.Keyword(null,"unknown-op","unknown-op",1900385996),new cljs.core.Keyword(null,"msg","msg",-1386103444),msg], null));
});
shadow.remote.runtime.shared.process = (function shadow$remote$runtime$shared$process(p__18675,p__18676){
var map__18677 = p__18675;
var map__18677__$1 = cljs.core.__destructure_map(map__18677);
var runtime = map__18677__$1;
var state_ref = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__18677__$1,new cljs.core.Keyword(null,"state-ref","state-ref",2127874952));
var map__18678 = p__18676;
var map__18678__$1 = cljs.core.__destructure_map(map__18678);
var msg = map__18678__$1;
var op = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__18678__$1,new cljs.core.Keyword(null,"op","op",-1882987955));
var call_id = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__18678__$1,new cljs.core.Keyword(null,"call-id","call-id",1043012968));
var state = cljs.core.deref(state_ref);
var op_handler = cljs.core.get_in.cljs$core$IFn$_invoke$arity$2(state,new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"ops","ops",1237330063),op], null));
if(cljs.core.truth_(call_id)){
var cfg = cljs.core.get_in.cljs$core$IFn$_invoke$arity$2(state,new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"call-handlers","call-handlers",386605551),call_id], null));
var call_handler = cljs.core.get_in.cljs$core$IFn$_invoke$arity$2(cfg,new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"handlers","handlers",79528781),op], null));
if(cljs.core.truth_(call_handler)){
cljs.core.swap_BANG_.cljs$core$IFn$_invoke$arity$variadic(state_ref,cljs.core.update,new cljs.core.Keyword(null,"call-handlers","call-handlers",386605551),cljs.core.dissoc,cljs.core.prim_seq.cljs$core$IFn$_invoke$arity$2([call_id], 0));

return (call_handler.cljs$core$IFn$_invoke$arity$1 ? call_handler.cljs$core$IFn$_invoke$arity$1(msg) : call_handler.call(null,msg));
} else {
if(cljs.core.truth_(op_handler)){
return (op_handler.cljs$core$IFn$_invoke$arity$1 ? op_handler.cljs$core$IFn$_invoke$arity$1(msg) : op_handler.call(null,msg));
} else {
return shadow.remote.runtime.shared.unhandled_call_result(cfg,msg);

}
}
} else {
if(cljs.core.truth_(op_handler)){
return (op_handler.cljs$core$IFn$_invoke$arity$1 ? op_handler.cljs$core$IFn$_invoke$arity$1(msg) : op_handler.call(null,msg));
} else {
if(cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(new cljs.core.Keyword(null,"client-not-found","client-not-found",-1754042614),op)){
return shadow.remote.runtime.shared.unhandled_client_not_found(runtime,msg);
} else {
return shadow.remote.runtime.shared.reply_unknown_op(runtime,msg);

}
}
}
});
shadow.remote.runtime.shared.run_on_idle = (function shadow$remote$runtime$shared$run_on_idle(state_ref){
var seq__18679 = cljs.core.seq(cljs.core.vals(new cljs.core.Keyword(null,"extensions","extensions",-1103629196).cljs$core$IFn$_invoke$arity$1(cljs.core.deref(state_ref))));
var chunk__18681 = null;
var count__18682 = (0);
var i__18683 = (0);
while(true){
if((i__18683 < count__18682)){
var map__18687 = chunk__18681.cljs$core$IIndexed$_nth$arity$2(null,i__18683);
var map__18687__$1 = cljs.core.__destructure_map(map__18687);
var on_idle = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__18687__$1,new cljs.core.Keyword(null,"on-idle","on-idle",2044706602));
if(cljs.core.truth_(on_idle)){
(on_idle.cljs$core$IFn$_invoke$arity$0 ? on_idle.cljs$core$IFn$_invoke$arity$0() : on_idle.call(null));


var G__18715 = seq__18679;
var G__18716 = chunk__18681;
var G__18717 = count__18682;
var G__18718 = (i__18683 + (1));
seq__18679 = G__18715;
chunk__18681 = G__18716;
count__18682 = G__18717;
i__18683 = G__18718;
continue;
} else {
var G__18719 = seq__18679;
var G__18720 = chunk__18681;
var G__18721 = count__18682;
var G__18722 = (i__18683 + (1));
seq__18679 = G__18719;
chunk__18681 = G__18720;
count__18682 = G__18721;
i__18683 = G__18722;
continue;
}
} else {
var temp__5804__auto__ = cljs.core.seq(seq__18679);
if(temp__5804__auto__){
var seq__18679__$1 = temp__5804__auto__;
if(cljs.core.chunked_seq_QMARK_(seq__18679__$1)){
var c__5568__auto__ = cljs.core.chunk_first(seq__18679__$1);
var G__18723 = cljs.core.chunk_rest(seq__18679__$1);
var G__18724 = c__5568__auto__;
var G__18725 = cljs.core.count(c__5568__auto__);
var G__18726 = (0);
seq__18679 = G__18723;
chunk__18681 = G__18724;
count__18682 = G__18725;
i__18683 = G__18726;
continue;
} else {
var map__18688 = cljs.core.first(seq__18679__$1);
var map__18688__$1 = cljs.core.__destructure_map(map__18688);
var on_idle = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__18688__$1,new cljs.core.Keyword(null,"on-idle","on-idle",2044706602));
if(cljs.core.truth_(on_idle)){
(on_idle.cljs$core$IFn$_invoke$arity$0 ? on_idle.cljs$core$IFn$_invoke$arity$0() : on_idle.call(null));


var G__18727 = cljs.core.next(seq__18679__$1);
var G__18728 = null;
var G__18729 = (0);
var G__18730 = (0);
seq__18679 = G__18727;
chunk__18681 = G__18728;
count__18682 = G__18729;
i__18683 = G__18730;
continue;
} else {
var G__18731 = cljs.core.next(seq__18679__$1);
var G__18732 = null;
var G__18733 = (0);
var G__18734 = (0);
seq__18679 = G__18731;
chunk__18681 = G__18732;
count__18682 = G__18733;
i__18683 = G__18734;
continue;
}
}
} else {
return null;
}
}
break;
}
});

//# sourceMappingURL=shadow.remote.runtime.shared.js.map
